#!/usr/bin/perl

#Author: Jason Penton

use File::Tail;

$data_file='/var/log/kamailio_debug';           #set to your location of kamailio log file
$numlines=500;					#number of lines to buffer before printing report

my %hash = ();
my %hashoffile = ();
my $prev_line = "";
my $count=0;
my $totalsize=0;

$file=File::Tail->new($data_file);

#foreach $line (@raw_data) {
while (defined($line=$file->read)) {
   $line =~ /\]:.*\[.*\] (.*)/;
   $line = $1;
   if ($line =~ /returns address/) {
      $line =~ /frag\. (\w+) \(size=(\d+)/;
      if (exists $hash{$1} && defined $hash{$1}) 
      { 
         print "Warning: collision for hash and value is $hash{$1}\n";
      }
      $hash_val = "$2 ($prev_line)";
      $hash{$1} = "mysize=$2 " . $prev_line;
   }
   if ($line =~ /freeing frag. (\w+)/) {
     if (!exists $hash{$1}) {
        print "Warning: trying to free frag that doesnt seem to exist ($1)\n";
     } else {
        delete $hash{$1};
     }
   }
   $prev_line = $line;
   chomp($prev_line);
   $count = $count + 1;
   if ($count > $numlines) {
      print "\n\n\n\n\n\n*****************************************************************************************************************************************************\n";
      print "DUMPING ALL UNFREED MEMORY FRAGMENTS (" . keys( %hash ) . ")\n";
      print "*****************************************************************************************************************************************************\n";
      for my $key ( keys %hash ) {
         my $value = $hash{$key};
         $value =~ /mysize=(\d+).*(called from .*)/;

         if (exists $hashoffile{$2} && defined $hashoffile{$2})
         {
            $increment = $hashoffile{$2};
            $increment = $increment + 1;
            $hashoffile{$2} = "$increment:$1";
         } else {
            $hashoffile{$2} = "1:$1";
         }
      }

      $totalsize = 0;

      for my $key ( keys %hashoffile ) {
         my $value = $hashoffile{$key};
         @details = split(/:/,$value);
         $sumsize = $details[0] * $details[1];
         $totalsize = $totalsize + $sumsize;
format = 
@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<            @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<      @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$key                                                                         $details[0]                                      $sumsize
.
write;
         $hashoffile{$key} = 0;
      }
      %hashoffile = ();

      print "************************************************************TOTAL BYTES HELD IN FRAGMENTS: $totalsize***************************************************************\n\n\n\n\n\n";
      $count = 0;
   }


}

close(LOGFILE);
